Imports Microsoft.VisualBasic
Imports Telerik.WebControls


Namespace [Custom]
    Public Class CustomGrid
        Inherits CompositeControl
        Private _gridContextMenu As RadMenu
        Private _grid As RadGrid
        Private _clickedRowIndexField As HiddenField
        Private _ajaxManager As RadAjaxManager


        Public Sub New()
        End Sub

        <PersistenceMode(PersistenceMode.InnerProperty)> _
        Public ReadOnly Property Grid() As RadGrid
            Get
                If _grid Is Nothing Then
                    _grid = New RadGrid()
                End If

                Return _grid
            End Get
        End Property

        Friend ReadOnly Property GridContextMenu() As RadMenu
            Get
                If _gridContextMenu Is Nothing Then
                    _gridContextMenu = New RadMenu()
                    _gridContextMenu.IsContext = True
                    _gridContextMenu.ContextMenuElementID = "none"

                    Dim item1 As New RadMenuItem()
                    item1.ID = "Add"
                    item1.Text = "Add"
                    _gridContextMenu.Items.Add(item1)

                    Dim item2 As New RadMenuItem()
                    item2.ID = "Edit"
                    item2.Text = "Edit"
                    _gridContextMenu.Items.Add(item2)

                    Dim item3 As New RadMenuItem()
                    item3.ID = "Delete"
                    item3.Text = "Delete"

                    _gridContextMenu.Items.Add(item3)
                End If

                Return _gridContextMenu
            End Get
        End Property

        Friend ReadOnly Property ClickedRowIndexField() As HiddenField
            Get
                If _clickedRowIndexField Is Nothing Then
                    _clickedRowIndexField = New HiddenField()
                End If

                Return _clickedRowIndexField
            End Get
        End Property

        Friend ReadOnly Property AjaxManager() As RadAjaxManager
            Get
                If _ajaxManager Is Nothing Then
                    _ajaxManager = New RadAjaxManager()
                End If

                Return _ajaxManager
            End Get
        End Property

        Protected Overloads Overrides Sub CreateChildControls()
            Grid.ID = "RadGrid1"
            Me.Controls.Add(Grid)

            GridContextMenu.ID = "GridContextMenu"
            Me.Controls.Add(GridContextMenu)
            AddHandler GridContextMenu.ItemClick, AddressOf GridContextMenu_ItemClick

            AjaxManager.ID = "AjaxManager"
            Me.Controls.Add(AjaxManager)
            AjaxManager.AjaxSettings.AddAjaxSetting(Me, Me, Nothing)

            ClickedRowIndexField.ID = "radGridClickedRowIndex"
            Me.Controls.Add(ClickedRowIndexField)

            Me.Grid.ClientSettings.ClientEvents.OnRowContextMenu = "RowContextMenu"

            Me.Page.ClientScript.RegisterClientScriptBlock(GetType(String), "ContextMenu", String.Format("function RowContextMenu(index, e){{document.getElementById(""{0}"").value = index;var menu = window['{1}'];menu.Show(e);e.cancelBubble = true;e.returnValue = false;if (e.stopPropagation){{e.stopPropagation();e.preventDefault();}}this.SelectRow(this.Rows[index].Control, true);}}", ClickedRowIndexField.ClientID, GridContextMenu.ClientID), True)
            MyBase.CreateChildControls()
        End Sub

        Private Sub GridContextMenu_ItemClick(ByVal sender As Object, ByVal e As RadMenuEventArgs)
            Dim radGridClickedRowIndex As Integer = Convert.ToInt32(HttpContext.Current.Request.Form(ClickedRowIndexField.UniqueID))

            Select Case e.Item.Text
                Case "Edit"
                    Me.Grid.Items(radGridClickedRowIndex).Edit = True
                    Me.Grid.Rebind()
                    Exit Select
                Case "Add"
                    Me.Grid.MasterTableView.IsItemInserted = True
                    Me.Grid.Rebind()
                    Exit Select
                Case "Delete"
                    Me.Grid.MasterTableView.PerformDelete(Me.Grid.Items(radGridClickedRowIndex))
                    Exit Select
            End Select
        End Sub
    End Class
End Namespace

